package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.types.DatabaseType

public interface CreateDeleteQueryScope<TargetTableUserExtension : Any, QueryUserExtension : Any> : _CommonCreateQueryScope<QueryUserExtension> {
	public val targetTable: SelectedTable<TargetTableUserExtension, QueryUserExtension>

	public fun where(expression: Expression<Boolean, DatabaseType.BOOLEAN, QueryUserExtension>)

	public fun limit(size: UInt)

	public val returning: _CommonCreateQueryScope._ReturningClauseScope<QueryUserExtension>
}