package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.types.DatabaseType

public interface CreateSelectQueryScope<QueryUserExtension : Any> : _CommonCreateQueryScope<QueryUserExtension>, _CommonCreateQueryScope._ReturningClauseScope<QueryUserExtension>{
	public fun where(expression: Expression<Boolean, DatabaseType.BOOLEAN, QueryUserExtension>)

	public fun limit(size: UInt)

	@Suppress("SpellCheckingInspection")
	public fun offsetedLimit(offset: ULong, size: UInt)
}