package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.table.Column
import ru.landgrafhomyak.serdha.api.v0.ddl.table.UniqueIndex
import ru.landgrafhomyak.serdha.api.v0.ddl.types.DatabaseType

@Suppress("ClassName")
public interface _CreateInsertOrCopyQueryScope<TargetTableUserExtension : Any, QueryUserExtension : Any> : _CommonCreateQueryScope<QueryUserExtension> {
	public val insertedValues: SelectedTable<TargetTableUserExtension, QueryUserExtension>

	@Suppress("ClassName")
	public interface _UpsertClauseScope<TargetTableUserExtension : Any, QueryUserExtension : Any> {
		public fun <RT, DT : DatabaseType<RT>> oldColumnValue(c: Column<RT, DT, TargetTableUserExtension>): Expression<RT, DT, QueryUserExtension>

		public fun <RT, DT : DatabaseType<RT>> updateColumn(c: Column<RT, DT, TargetTableUserExtension>, e: Expression<RT, DT, QueryUserExtension>)
	}

	public fun onConflictUpdate(u: UniqueIndex<TargetTableUserExtension>, c: (_UpsertClauseScope<TargetTableUserExtension, QueryUserExtension>) -> Unit)

	public fun onConflictThrow(u: UniqueIndex<TargetTableUserExtension>)

	public fun onConflictIgnore(u: UniqueIndex<TargetTableUserExtension>)

	public val returningInserted: _CommonCreateQueryScope._ReturningClauseScope<QueryUserExtension>

	@Suppress("ClassName")
	public interface _ReturningUpdatedClauseScope<TargetTableUserExtension : Any, QueryUserExtension : Any> : _CommonCreateQueryScope._ReturningClauseScope<QueryUserExtension> {
		public fun <RT, DT : DatabaseType<RT>> oldColumnValue(c: Column<RT, DT, TargetTableUserExtension>): Expression<RT, DT, QueryUserExtension>
	}

	public val returningUpdated: _ReturningUpdatedClauseScope<TargetTableUserExtension, QueryUserExtension>
}





















